--[[

		Advanced Radio Script
		  Aug. 26th. 2019
		  
			   Detch
			   
]]

-- [1] Variables
Map_Locations = {};

local cs2d_radio = 
{
	{0,"Affirmative!","radio/affirm.ogg"},
	{1,"Need Backup!","radio/backup.ogg"},
	{2,"Get out of there she's gonna blow!","radio/blow.ogg"},
	{3,"Bomb has been defused!","radio/bombdef.ogg"},
	{4,"Bomb has been planted!","radio/bombpl.ogg"},
	{5,"Sector clear!","radio/clear.ogg"},
	{6,"Cover me!","radio/coverme.ogg"},
	{7,"Counter-Terrorists Win","radio/ctwin.ogg"},
	{8,"Enemy down!","radio/enemydown.ogg"},
	{9,"Enemy spotted!","radio/enemys.ogg"},
	{10,"Team fall back!","radio/fallback.ogg"},
	{11,"Taking fire, need assistance!","radio/fireassis.ogg"},
	-- {12,"Fire in the hole!","radio/fireinhole.ogg"},
	{13,"Follow me!","radio/followme.ogg"},
	{14,"Get in position and wait for my go!","radio/getinpos.ogg"},
	{15,"Go, go, go!","radio/go.ogg"},
	{16,"Hostage down!","radio/hosdown.ogg"},
	{17,"I'm in position!","radio/inpos.ogg"},
	{18,"Okay, let's go!","radio/letsgo.ogg"},
	{19,"Lock and load!","radio/locknload.ogg"},
	{20,"Teammate down!","radio/matedown.ogg"},
	{21,"Alright, let's move out!","radio/moveout.ogg"},
	{22,"Negative!","radio/negative.ogg"},
	{23,"Hold this position!","radio/position.ogg"},
	{24,"Regroup team!","radio/regroup.ogg"},
	{25,"Report in, team!","radio/reportin.ogg"},
	{26,"Reporting in!","radio/reportingin.ogg"},
	{27,"Hostage has been rescued!","radio/rescued.ogg"},
	{28,"Roger that!","radio/roger.ogg"},
	{29,"Round draw!","radio/rounddraw.ogg"},
	{30,"Stick together team!","radio/sticktog.ogg"},
	{31,"Storm the front!","radio/stormfront.ogg"},
	{32,"You take the point!","radio/takepoint.ogg"},
	{33,"Terrorists Win","radio/terwin.ogg"},
	{34,"Protect the V.I.P. team!","radio/vip.ogg"}
}

adv_user = {};

function initialize_adv_user(id, image_initialize)
adv_user[id] =
{
	location = "",
	img = {},
	
	spam_delay = 0,
	
};
	if ( image_initialize ) then
	reqcld(id,4,"gfx/hud_symbols.bmp");
	end
	
end

--[2] Util functions

function Toggle_Hooks(mode)
	if ( mode ) then
	
	addhook("sayteam","adv_sayteam")
	addhook("radio","adv_radio")
	addhook("movetile","adv_movetile")
	addhook("clientdata","adv_clientdata")
	addhook("join","adv_join");
	addhook("parse","adv_extract");
	
	end
	
end

function Action_Visual(id, atype)
	if ( adv_user[id].image ~= -1 ) then
	image_effect(id,adv_user[id].image[atype],"pos"..player(id,"x")..","..player(id,"y")..",0","alpha1.0","talpha2000,0.0","tmove2000,"..player(id,"x")..","..(player(id,"y")-16))
	end
end

function convertXY(id, x, y)
local game_scale = tonumber(game("mp_hudscale")); 
	
	if ( game_scale >= 2 ) then
	print("\169230230230[\169225075075WARNING\169230230230]: \169235200100This script isn't compatible with scale mode 2, swtiching to 0..")
	parse("mp_hudscale 0");
	game_scale = 0;
	end

id, x, y = tonumber(id), tonumber(x), tonumber(y)
	if ( game_scale == 0 ) then 
	local width, height = player(id,"exists") == false and 850 or player(id,"screenw"), player(id,"exists") == false and 480 or player(id,"screenh");
		if ( id ~= 0 ) then
		return (x / 850) * width, (y / 480) * height
		end
	elseif ( game_scale == 1 ) then
	return x, y;
	end
	
end

function table.uneval(t,l)-- Table uneval by MikuAuahDark
	local str="{\r\n"
	l=l or 1
	for n,v in pairs(t) do
		if v==t then error("infinite-loop table detected!") end
		if tostring(n):find("%s") then
			str=str..string.rep("\t",l).."[\""..n.."\"]="
		elseif tonumber(n) then
			str=str..string.rep("\t",l).."["..n.."]="
		else
			str=str..string.rep("\t",l)..n.."="
		end
		if type(v)=="table" then str=str..table.uneval(v,l+1)..",\r\n"
		elseif type(v)=="number" then str=str..tonumber(v)..",\r\n"
		elseif type(v)=="string" then str=str.."\""..v:gsub("\"","\\\"").."\",\r\n"
		elseif type(v)=="boolean" then str=str..tostring(v)..",\r\n"
		else str=str.."\""..tostring(v).."\",\r\n" end
	end
	return str..string.rep("\t",l-1).."}"
end

--lazy to make cheap version, just brought function that I made for my custom maps.
function hudtxts(mode, auto_scale, player_id, text_color, hud_id, text, x, y , ali, vali, size, ... )
	
	if ( string.find(text,"\174") ) then
	x = x+75;
	end
			
local game_scale = tonumber(game("mp_hudscale")); 
local temp_x = x;
	if ( game_scale == 1 ) then 
	auto_scale = false
	end
			
	if ( ... ) then 
	
		for k, cmd in pairs{...} do
		
			if ( cmd:sub(1,6) == "fadein" ) then
			x = -999
			end
					
		end
		
	end
				
ali = ali or 0; vali = vali or 0;
text_color = ( type(text_color) == "string" ) and text_color or "255220000" --// Set default CS2D color if type is not string
	
	if ( mode == 0 ) then --// default hudtxt function
		
		if ( player_id == 0 ) then --// Parse hudtxt function for everyone in game.
			
			for _, aid in pairs(player(0,"table")) do
			local t_size = size or 13;
			t_size = ( type(t_size) == "string" and t_size:find("a") and game_scale ~= 1 ) and (tonumber(t_size:sub(2))*player(aid,"screenw"))/850 or t_size:sub(2)
			
			local nx, ny;
			nx = ( auto_scale ) and (x/850) * player(aid,"screenw") or x;
			ny = ( auto_scale ) and (y/480) * player(aid,"screenh") or y;
			
			hudtxts(0, false, aid, text_color, hud_id, text,nx, ny, ali, vali, t_size);
			end
		
		else
		
		temp_x = ( auto_scale ) and ( temp_x/850 ) * player(player_id,"screenw") or temp_x;
		x = ( auto_scale ) and ( x/850 ) * player(player_id,"screenw") or x;
		y = ( auto_scale ) and ( y/480 ) * player(player_id,"screenh") or y;
		
		size = size or 13; 
		
			if ( type(size) == "string" and size:find("a") ) then
				
				if ( game_scale ~= 1 ) then
				size = ( tonumber(size:sub(2)) * player(player_id,"screenw"))/850
				else
				
				size = size:gsub("a","");
				end
				
			end
			
		-- size = ( type(size) == "string" and size:find("a") and game_scale ~= 1 ) and ( tonumber(size:sub(2)) * player(player_id,"screenw"))/850 or size;
		
		parse("hudtxt2 "..player_id.." "..hud_id.." \"\169"..text_color..""..text.."\" "..x.." "..y.." "..ali.." "..vali.." "..size);
		
		end
	
	elseif ( mode == 1 ) then --// set hudtxt in specific position
	auto_scale = false;
		if ( player_id == 0 ) then
			
			for _, aid in pairs(player(0,"table")) do
			local t_size = size or 13;
			-- t_size = ( type(t_size) == "string" and t_size:find("a") ) and (tonumber(t_size:sub(2))*player(aid,"screenw"))/850 or t_size
			-- msg(t_size)
			hudtxts(1, false, aid, text_color, hud_id, text, x, y, ali, vali, t_size);
			end
			
		else
			
			--// Tweak coordinates depend on hudscale
			if ( game_scale == 0 ) then
			x = ( x - player(player_id,"x"))*(player(player_id,"screenw")/850)+(player(player_id,"screenw")/2)
			y = ( y - player(player_id,"y"))*(player(player_id,"screenh")/480)+(player(player_id,"screenh")/2)
			size = size or 13; 
			size = ( type(size) == "string" and size:find("a") ) and ( tonumber(size:sub(2)) * player(player_id,"screenw"))/850 or size;
			
			
			elseif ( game_scale == 1 ) then
			x = ( x - player(player_id,"x"))+424.5
			y = ( y - player(player_id,"y"))+240.5
			size = ( type(size) == "string" and size:find("a") ) and tonumber(size:sub(2))-6 or size-6;
			else --// I didn't set for other scale, just use 0 and 1 
			
			x = ( x - player(player_id,"x"))
			y = ( y - player(player_id,"y"))
			
			end
		
		parse("hudtxt2 "..player_id.." "..hud_id.." \"\169"..text_color..""..text.."\" "..x.." "..y.." "..ali.." "..vali.." "..size);
		end
		
	end
	
local tbl , command , comma = {}
local effects = {"alpha","color","move","fadein","fadeout"}
	
	local function cvt_tbl(n,cmd)
	command, comma = cmd:sub(n)
		while ( #command ~= 0 ) do
		comma = command:find(",") or #command+1
				  
		tbl[#tbl+1] = command:sub(1,comma-1)
		command = command:sub(comma+1)
		end
			
		if ( cmd:sub(1,5) == "alpha" ) then
		parse("hudtxtalphafade "..player_id.." "..hud_id.." "..tbl[1].." "..tbl[2]);
		
		elseif ( cmd:sub(1,5) == "color" ) then
		parse("hudtxtcolorfade "..player_id.." "..hud_id.." "..tbl[1].." "..tbl[2].." "..tbl[3].." "..tbl[4]);
		
		elseif ( cmd:sub(1,4) == "move" ) then
			if ( auto_scale ) then
			tbl[2], tbl[3] = convertXY(player_id,tbl[2],tbl[3]);
			end
		parse("hudtxtmove "..player_id.." "..hud_id.." "..tbl[1].." "..tbl[2].." "..tbl[3]);
			
		elseif ( cmd:sub(1,6) == "fadein" ) then
		--[[ fade in parameter 
			1. Appearing Duration
			2. Alpha
		--]]
		parse("hudtxtalphafade "..player_id.." "..hud_id.." 1 0.0");
		parse("hudtxtmove "..player_id.." "..hud_id.." 1 -9999 -9999");
		timer(1,"parse","hudtxtmove "..player_id.." "..hud_id.." 1 "..temp_x.." "..y);
		timer(100,"parse", "hudtxtalphafade "..player_id.." "..hud_id.." "..tbl[1].." "..tbl[2]);
			
		
		elseif ( cmd:sub(1,7) == "fadeout" ) then
		--[[ fade-out parameter
			1. Disappear after x miliseecond
			2. Disappear Duration
			3. Alpha
		]]
		
		timer(tbl[1],"parse","hudtxtalphafade "..player_id.." "..hud_id.." "..tbl[2].." "..tbl[3]);
		end
		
	tbl = {};		
	end
	
	if ( ... ) then 
	
		for k, cmd in pairs{...} do
		
			for _, list in pairs(effects) do
	
				if ( cmd:sub(1,#list) == list ) then
				cvt_tbl(#list+1,cmd);
			
				break
				end
				
			end
		
		end
	
	end
	
end
function image_effect(id,image,...)
local tbl , command , comma = {}
local lists = {"shadow","freeimage","alpha","blend","color","frame","pos","scale","hitzone","talpha","tcolor","tframe","tmove","trotate","tconstant","tscale"};
	
local function cvt_tbl(n,cmd)
command, comma = cmd:sub(n)
	while ( #command ~= 0 ) do
	comma = command:find(",") or #command+1
          
	tbl[#tbl+1] = command:sub(1,comma-1)
	command = command:sub(comma+1)
	end
	
	if ( cmd:sub(1,5) == "alpha" ) then
	imagealpha(image,tbl[1])
	
	elseif ( cmd:sub(1,9) == "freeimage" ) then
	freeimage(image);
	image = 0;
	
	elseif ( cmd:sub(1,6) == "shadow" ) then
	imageshadow(image,tbl[1]);
	
	elseif ( cmd:sub(1,5) == "blend" ) then
	imageblend(image,tbl[1])
	
	elseif ( cmd:sub(1,5) == "color" ) then
	imagecolor(image,tbl[1],tbl[2],tbl[3])
	
	elseif ( cmd:sub(1,5) == "frame" ) then
	imageframe(image,tbl[1])
	
	elseif ( cmd:sub(1,3) == "pos" ) then
		if ( tbl[1]:sub(1,1)=="a" ) then
		tbl[1], tbl[2] = convertXY(id,tbl[1]:sub(2),tbl[2])
				
		end
	
	imagepos(image,tbl[1],tbl[2],tbl[3])
	elseif ( cmd:sub(1,5) == "scale" ) then
		if ( tbl[1]:sub(1,1)=="a" ) then
		tbl[1], tbl[2] = convertXY(id,tbl[1]:sub(2),tbl[2])
		end
	imagescale(image,tbl[1],tbl[2])
	
	elseif ( cmd:sub(1,7) == "hitzone" ) then
	tbl[1], tbl[2], tbl[3], tbl[4], tbl[5] = tonumber(tbl[1]), tonumber(tbl[2]), tonumber(tbl[3]), tonumber(tbl[4]), tonumber(tbl[5])
	imagehitzone(image,tbl[1],tbl[2],tbl[3],tbl[4],tbl[5])
		
	elseif ( cmd:sub(1,6) == "talpha" ) then

	tween_alpha(image,tbl[1],tbl[2])
	
	elseif ( cmd:sub(1,6) == "tcolor" ) then
	tween_color(image,tbl[1],tbl[2],tbl[3],tbl[4])
	
	elseif ( cmd:sub(1,6) == "tframe" ) then
	tween_frame(image,tbl[1],tbl[2])
	
	elseif ( cmd:sub(1,5) == "tmove" ) then
		if ( tbl[1]:sub(1,1)=="a" ) then
		tbl[2], tbl[3] = convertXY(id,tbl[2]:sub(2),tbl[3])
		end
	tween_move(image,tbl[1],tbl[2],tbl[3],tbl[4])
	elseif ( cmd:sub(1,7) == "trotate" ) then
	tween_rotate(image,tbl[1],tbl[2])
	
	elseif ( cmd:sub(1,9) == "tconstant" ) then
	
	tween_rotateconstantly(image,tbl[1])
	
	elseif ( cmd:sub(1,6) == "tscale" ) then
	tween_scale(image,tbl[1],tbl[2],tbl[3])
	end
tbl = {}
end

	if ( type(image) == "table" ) then
		for _, n in ipairs(image) do
		image_effect(id,n,...)
		end
	else
	
		for k,cmd in pairs{...} do
			
			for _,list in pairs(lists) do
			--print("First : In loop, command name : "..list)
			-- print("Second : Matching test - "..cmd:sub(1,#list).."(cmd:sub(1,#list) == "..list.."(list)")
				if ( cmd:sub(1,#list) == list ) then
				-- print("matched!, performing function : cvt_tbl("..(#list+1)..","..list..")")
				cvt_tbl(#list+1,cmd)
				break
				end
			end
			
		end
	end
end

--[3] Hook and game functions


function adv_clientdata(id, mode, data1, data2)
	
	if ( mode == 4 ) then
		
		if ( checksumfile("gfx/hud_symbols.bmp") ~= data2 ) then
		msg2(id,"\169230230230[\169160220160Inform\169230230230]: \169220210120The script found that you are using modified image of \"hud_symbols.bmp\" file. ")
		msg2(id,"\169220210120         Please use default file for better gameplay.")
		adv_user[id].image = -1
		else
		adv_user[id].image = {image("<spritesheet:gfx/hud_symbols.bmp:64:64>",0,0,3,id), image("<spritesheet:gfx/hud_symbols.bmp:64:64>",0,0,3,id)};
		image_effect(id,adv_user[id].image,"alpha0.0","blend1","color0,255,0","scale0.5,0.5")
		imageframe(adv_user[id].image[1],9);
		imageframe(adv_user[id].image[2],11);
		
		end
		
	end
	
end


function adv_movetile(id, x, y)
	if ( type(Map_Locations) == "table" ) then
	
		for k, locations in pairs(Map_Locations) do
			
			if ( x >= locations[2] and x <= locations[3] ) and ( y >= locations[4] and y <= locations[5] ) then
			adv_user[id].location = locations[1];
			hudtxts(0, true, id,"180230180", 0, locations[1],48, 105 ,1, 0, "a8.5");
			break;
			
			else
			
			adv_user[id].location = "";
			end
			
		end
		
	end
	
end


function adv_radio(id, radio)
	if ( type(Map_Locations) == "table" ) then

		if adv_user[id].location ~= "" then
		
			for _, rtbl in pairs(cs2d_radio) do
			
				if ( tonumber(radio) == rtbl[1] ) then
					
					if ( adv_user[id].spam_delay == 0 and player(id,"health") > 0 ) then
					adv_user[id].spam_delay = 2;
					Action_Visual(id, 1);
					timer(2000,"parse","lua adv_user["..id.."].spam_delay=0");
					local team = ( player(id,"team") == 1 ) and {player(0,"team1"), "\169255020020"} or {player(0,"team2"), "\169050150255"}
					
						for _, teammate in pairs(team[1]) do
						msg2(teammate,team[2]..""..player(id,"name").."  \169255220000@\169000255000"..adv_user[id].location.." \169255220000(Radio): "..rtbl[2]);
						parse("sv_sound2 "..teammate.." \""..rtbl[3].."\"");
						end
					
					return 1
					else
					
					return 1
					end
					
			 
				end
				
			end
		
		end
				
	end
	
end


function adv_sayteam(id, txt)
	
	if ( type(Map_Locations) == "table" ) then
		
		if adv_user[id].location ~= "" then
		
			if ( adv_user[id].spam_delay == 0 and player(id,"health") > 0 ) then
			adv_user[id].spam_delay = 1;
			Action_Visual(id, 2);
			timer(1000,"parse","lua adv_user["..id.."].spam_delay=0");
			
			local team = ( player(id,"team") == 1 ) and {player(0,"team1"), "\169255020020"} or {player(0,"team2"), "\169050150255"}
			txt = txt:gsub("@C","");
				for _, teammate in pairs(team[1]) do
				msg2(teammate,team[2]..""..player(id,"name").."  \169255220000@\169000255000"..adv_user[id].location.." \169255220000(Team): "..txt);
				end
				
			end
			
		return 1;
		
		end
		
	else
	
	return 0
	end
	
end

function adv_join(id)
initialize_adv_user(id,true);
end

function adv_extract(cmd)
	
	if ( cmd == "export" ) then
	
	local file = io.open("maps/"..map("name")..".lcdf","w");
	file:write(table.uneval(Map_Locations));
	file:close();
	print("\169230230230[\169160220160Inform\169230230230]: \169220210120Successfully exported a location file.")
	return 2
	end
	
end

--[4] Execute once for finding data / map entities. 
do
local f = io.open("maps/"..map("name")..".lcdf","r");
	
	if f then
	local temp = loadstring("return "..f:read("*a"));
	Map_Locations = temp();
	f:close();
	print("\169230230230[\169160220160Inform\169230230230]: \169220210120Successfully loaded a location data file!");
	Toggle_Hooks(true);
	
	else
	local loc_con = false;
		for _,e in pairs(entitylist()) do
			
			if #entity(e.x,e.y,"trigger")>0 and entity(e.x,e.y,"typename")=="Info_NoBuildings" then
			local mx = entity(e.x,e.y,"int0")+e.x-1
			local my = entity(e.x,e.y,"int1")+e.y-1
			local name = entity(e.x,e.y,"trigger")
			table.insert(Map_Locations, { name, e.x, mx, e.y, my })
			parse("triggerposition "..e.x.." "..e.y)
			
			loc_con = true;
			end

			
		
			
			
		end
		
		if loc_con then
		print("\169230230230[\169160220160Inform\169230230230]: \169220210120Couldn't find location data file,map locations were added by map entities.")
		Toggle_Hooks(true);
		
		else
		print("\169230230230[\169160220160Inform\169230230230]: \169220210120Neither of data, entities were found, returning to default cs2d system..")
		Map_Locations = false;
		end
		
	end
end

